<template>
  <v-app>
    <v-content>
      <v-container fill-height fluid>
        <v-row justify="center" align="center" class="fill-height">
          <Uploader v-if="inProgress === false" @dispatch="startConverting"/>
          <Steppers v-else :stage="stage" :dlink="dlink" :filesConverted="filesConverted"/>
        </v-row>
      </v-container>
      <v-overlay v-if="stage >= 5">
        <v-progress-circular
          v-if="dlink === ''"
          :size="50"
          color="white"
          indeterminate
        ></v-progress-circular>
        <div align="center" justify="center" v-else>
          <v-row class="display-1">
            Conversion completed
          </v-row>
          <v-btn :href="dlink" @click="reset">
            Download
          </v-btn>
        </div>
      </v-overlay>
    </v-content>
  </v-app>
</template>

<script>
import Uploader from './components/Uploader.vue';
import Steppers from './components/Steppers.vue';

export default {
  name: 'App',

  components: {
    Uploader,
    Steppers,
  },

  data() {
    return {
      stages: ['PENDING', 'EXTRACTING', 'CONVERTING', 'COMPRESSING', 'DONE'],
      stage: 0,
      filesConverted: 0,
      inProgress: false,
      dlink: '',
    };
  },

  sockets: {
    end_result({ bucket_name: bucketName, object_name: objectName }) {
      this.$minio.presignedGetObject(bucketName, objectName, 24 * 60 * 60, (err, presignedUrl) => {
        if (err) {
          // console.log(err);
          return;
        }
        this.dlink = presignedUrl;
      });
    },
    progress({ stage }) {
      this.stage = this.stages.findIndex((e) => e === stage);
      // console.log(this.stage);
      if (stage === 'CONVERTING') {
        this.filesConverted += 1;
      }
      if (stage === 'DONE') {
        this.stage += 1;
      }
    },
  },

  methods: {
    reset() {
      this.stage = '';
      this.filesConverted = 0;
      this.inProgress = false;
      this.dlink = '';
    },
    startConverting() {
      this.inProgress = true;
    },
  },
};
</script>
